/*
   core/slot.cc
   This file is part of the Osirion project and is distributed under
   the terms of the GNU General Public License version 2.
*/

#include "core/slot.h"
#include "core/item.h"
#include "core/application.h"

namespace core
{

Slot::Slot()
{
	slot_item = 0;
	slot_flags = 0;
	slot_timestamp = 0;
	slot_last_fired = 0;
	
	slot_interval = 0;
	slot_lifespan = 0;
	slot_speed = 0.0f;

	
}

Slot::Slot(const math::Vector3f & location) :
	slot_location(location)
{
	slot_item = 0;
	slot_flags = 0;
	slot_timestamp = 0;
	slot_last_fired = 0;
	
	slot_interval = 0;;
	slot_lifespan = 0;
	slot_speed = 0.0f;
}

Slot::~Slot()
{
	slot_item = 0;
	slot_flags = 0;
	slot_timestamp = 0;
	slot_last_fired = 0;
	
	slot_interval = 0;
	slot_lifespan = 0;
	slot_speed = 0.0f;
}

void Slot::set_item(Item *item)
{
	slot_item = item;
	set_timestamp(game() ? game()->timestamp() : 1);
}

} // namespace core

