/*
   base/spacemine.h
   This file is part of the Osirion project and is distributed under
   the terms and conditions of the GNU General Public License version 2
*/

#ifndef __INCLUDED_BASE_PROJECTILE_H__
#define __INCLUDED_BASE_PROJECTILE_H__

#include "core/entity.h"

namespace game
{

class Projectile : public core::EntityDynamic
{
public:
	Projectile(unsigned long lifespan);
	virtual ~Projectile();
	
	virtual void upkeep(const unsigned long timestamp);
	
	virtual void collision(Entity *other);
	
	virtual void frame(const unsigned long elapsed);

private:
	unsigned long projectile_timestamp;
	
	unsigned long projectile_lifespan;
};

} // namespace game

#endif // __INCLUDED_BASE_PROJECTILE_H__

