/*
   base/spacemine.h
   This file is part of the Osirion project and is distributed under
   the terms and conditions of the GNU General Public License version 2
*/

#ifndef __INCLUDED_BASE_SPACEMINE_H__
#define __INCLUDED_BASE_SPACEMINE_H__

#include "core/entity.h"
#include "base/template.h"

namespace game
{

class SpaceMine : public core::EntityDynamic
{
public:
	SpaceMine(const core::Info *info);
	virtual ~SpaceMine();
	
	virtual void upkeep(const unsigned long timestamp);
	
	virtual void collision(Entity *other);
	
	virtual void frame(const unsigned long elapsed);

	static inline void set_template (const Template *entitytemplate) {
		spacemine_template = entitytemplate;
	}

private:
	unsigned long		spacemine_detonated_timestamp;
	
	static const Template   *spacemine_template;
};

} // namespace game

#endif // __INCLUDED_BASE_SPACEMINE_H__

